#!/tvbin/tivosh
# dumps the local timezone offset to a text file
# mostly borrowed from tivoweb

proc get_tzoffset {mfstz dst} {
global info db
	if { $mfstz <= 0 } {
		set tz $mfstz
	} else {
		set tzlist "-5 -6 -7 -8 -9 -10 0 1 2 3 4 5 6 7 8 9 10 11 12 -1 -2 -3 -4 -11 -12"
		set tz [lindex $tzlist [expr $mfstz - 1]]
	}
	if { $dst == 2 } {
		set date [clock format [clock seconds] -format "%1d %w %1m %1H %1M"]
		scan $date "%d %d %d %d %d" dom dow month hour min
		set dlsval 0
		if {$::uktivo} {
			if {$month > 3 && $month < 10} {
				set dlsval 1
			} elseif {$month == 3 && $dom >= 25 && $dow == 0 && $hour >= 1} {

			set dlsval 1
		} elseif {$month == 3 && $dom >= 25 && $dow != 0 && ($dom-24-$dow >= 1) } {
			set dlsval 1
		}
	} else {
		if {$month > 4 && $month < 10} {
			set dlsval 1
		} elseif {$month == 4 && $dom > 7} {
			set dlsval 1
		} elseif {$month == 4 && $dom <= 7 && $dow == 0 && $hour >= 2} {
			set dlsval 1
		} elseif {$month == 4 && $dom <= 7 && $dow != 0 && ($dom-$dow > 0)} {
			set dlsval 1
		}
	}
	if {$dlsval == 0} {
		if {$month == 10 && $dom < 25} {
			set dlsval 1
		} elseif {$month == 10 && $dom >= 25 && $dow == 0 && $hour < 2} {
			set dlsval 1
		} elseif {$month == 10 && $dom >= 25 && $dow != 0 && ($dom-24-$dow < 1) } {
			set dlsval 1
		}
	}
	if {$dlsval == 1} {
		return [expr ($tz+1)*60*60]
	} else {
		return [expr $tz*60*60]
	}
	} else {
		return [expr $tz*60*60]
	}
}


proc get_tzoffset_one { } {
global info tzoffset tivoswversion version3 uktivo db
RetryTransaction {
	set swsystem [db $db open /SwSystem/ACTIVE]
	set tivoswversion [dbobj $swsystem get Name]
	set setup [db $db open /Setup]
	if { [string range $tivoswversion 0 2] >= 3.0 } {
		set version3 1
	} else {
		set version3 0
	}
	if {[PrefixMatches "2.5.5" $::tivoswversion]} {
		set uktivo 1
	} else {
		set uktivo 0
	}
	set suffix [string range $tivoswversion [expr [string length $tivoswversion] - 3] end]
	if { [lsearch "001 011 031" $suffix] >= 0 } {
		set dtivo 1
	} else {
		set dtivo 0
	}
	if { [PrefixMatches "2.5-" $tivoswversion] } {
		set datestr "Dec 25 2001"
	}
	if {$::version3} {
		set lconfig  [db $db open /State/LocationConfig]
		set setup [db $db open /State/ServiceConfig]
		if { [string range $tivoswversion 0 2] >=4.0 } {
		  set setuptz [dbobj $lconfig get TimeZoneOffset]
		} else {
		  set setuptz [dbobj $lconfig get TimeZoneOld]
		}
		set daylightsavings [dbobj $lconfig get DaylightSavingsPolicy]
	} else {
		set setuptz [dbobj $setup get TimeZone]
		set daylightsavings [dbobj $setup get DaylightSavingsPolicy]
	}
	if {$setuptz == ""} {
		set setuptz 0
	}
	if {$daylightsavings == ""} {
		set daylightsavings 2
	}
}
set tzoffset [get_tzoffset $setuptz $daylightsavings]
return $tzoffset
}

set info(path) [file dirname [info script]]
set db [dbopen]
set tzoffset [get_tzoffset_one]
set outf [open $info(path)/tzoffset.txt w]
puts $outf "# <tzoffset>$tzoffset</tzoffset>"
puts $outf "set info(tzoffset) $tzoffset"
close $outf
puts stdout "# <tzoffset>$tzoffset</tzoffset>"
puts stdout "set info(tzoffset) $tzoffset"
dbclose $db